/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.extension.dataset;

import org.seasar.extension.jdbc.ColumnNotFoundRuntimeException;

/**
 * @author higa
 * 
 */
public interface DataRow {

    public Object getValue(int index);

    public Object getValue(String columnName)
            throws ColumnNotFoundRuntimeException;

    public void setValue(int index, Object value);

    public void setValue(String columnName, Object value)
            throws ColumnNotFoundRuntimeException;

    public void remove();

    public DataTable getTable();

    public RowState getState();

    public void setState(RowState rowState);

    public void copyFrom(Object source);
}
