/*
 * Copyright 2004-2007 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.extension.jdbc;

import org.seasar.framework.exception.SRuntimeException;

/**
 * @author higa
 * 
 */
public final class ColumnNotFoundRuntimeException extends SRuntimeException {

    private static final long serialVersionUID = -5447029001596658262L;

    private String tableName_;

    private String columnName_;

    /**
     * @param componentKey
     */
    public ColumnNotFoundRuntimeException(String tableName, String columnName) {
        super("ESSR0068", new Object[] { tableName, columnName });
        tableName_ = tableName;
        columnName_ = columnName;
    }

    public String getTableName() {
        return tableName_;
    }

    public String getColumnName() {
        return columnName_;
    }
}